<?php
/*
Plugins "PayKeeper" for Shop-Script

 * @author Dorogov
 * @name PayKeeper
 * @description Плагин оплаты через PayKepeer.
 *
 * Поля, доступные в виде параметров настроек плагина, указаны в файле lib/config/settings.php.
 * @property-read string $pk_url_link
 * @property-read string $pk_secret_key
*/
class paykeeperPayment extends waPayment implements waIPayment 
{

		//Возвращаем валюту (Доступно только RUB)
		public function allowedCurrency()
    	{
			return $currency = 'RUB';
		}
		
		
		//Выводим свой шаблон страницы оплаты и перенаправляем клиента на страницу оплаты
		public function payment($payment_form_data, $order_data, $form_html = true)
    {
	        // заполняем обязательный элемент данных с описанием заказа
        if (empty($order_data['description'])) {
            $order_data['description'] = 'Заказ '.$order_data['order_id'];
        }

        // вызываем класс-обертку, чтобы гарантировать использование данных в правильном формате
        $order = waOrder::factory($order_data);

		//ТЕЛЕФОН пользователя (если ввел)
		$mobile_phone = '';
        if (!empty($order_data['contact_id'])) {
            $contact = new waContact($order_data['contact_id']);
            $mobile_phone = preg_replace('/^\s*\+\s*7/', '', $contact->get('phone.mobile', 'default'));
            $mobile_phone = preg_replace('/[^\d]/', '', $mobile_phone);
        }


		//НА ВСЯКИЙ СЛУЧАЙ добавим проверку анонимного платежа (некоторые плагины - позволяют формировать анонимный платеж)
		$pk_client_id = 0;
		if (!empty($order_data['contact_id'])) {
		$pk_client_id = $order_data['contact_id'];
        }
		
		//В связи с особенностями ПС строка clientid содердит в себе ID приложение ID мерчанта и ID зваказа разделенное ::: в формате строки
		
        // добавляем в платежную форму поля, требуемые платежной системой PayKeeper
        $hidden_fields = array(
            'clientid' => $pk_client_id.':::'.$this->app_id.':::'.$this->merchant_id,
            'sum'      => number_format($order->total, 2, '.', ''),
            'orderid'  => $order_data['order_id'],
            'phone'    => $mobile_phone,
        );
	    
		
		$transaction_data = $this->formalizeData($hidden_fields);
		
		
		//ВЫПОЛНЯЕМ ЗАПРОС ЗА ФОРМОЙ И ПЕРЕДАЕМ ПЕРЕМЕННУЮ В ШАБЛОН, ВЫВОДИМ ФОРМУ НА САЙТ
		$payment_parameters = http_build_query(array(   
            'clientid' => $pk_client_id.':::'.$this->app_id.':::'.$this->merchant_id,
            'sum'      => number_format($order->total, 2, '.', ''),
            'orderid'  => $order_data['order_id'],
            'phone'    => $mobile_phone,
													));
		$options = array("http"=>array(
					"method"=>"POST",
					"header"=>"Content-type: application/x-www-form-urlencoded",
					"content"=>$payment_parameters
					));
		$context = stream_context_create($options);

		// Это отобразит форму выбора способа оплаты.
		// С неё пользователь, выбрав способ оплаты, переходит на сайт нужной платёжной системы.
		$form_html = file_get_contents($this->pk_url_link, false, $context); 
		
		
		//Используем свой шалон (по желанию можно применить любой стиль, дабы подходил к дизайну)
        $view = wa()->getView();
		$view->assign('form_html', $form_html);
		return $view->fetch($this->path.'/templates/payment.html');
	}
	//
	//Инициируем callBack Функцию и подготавливаем переменные
	//
    protected function callbackInit($request)
    {
        if (!empty($request['id']) && !empty($request['sum']) && !empty($request['clientid']) && !empty($request['orderid']) && !empty($request['key'])) {
			//Новая обработка переменный в связи с особенностями ПС
			$pk_new_param = explode(':::',$request['clientid']);
			
		 	$this->order_id = $request['orderid']; 
    		$this->app_id = $pk_new_param[1]; 
    		$this->merchant_id = $pk_new_param[2];
		 } else {
            self::log($this->id, array('error' => 'empty required field(s)'));
            throw new waPaymentException('Empty required field(s)');
        }
      return parent::callbackInit($request);  
    }

 	//
	//Выполняем проверку и выводим сообщения
	//Так же пишем в лог, или обновляем статус заказа в случае успеха
	//
 protected function callbackHandler($request)
    {
		
        // приводим данные о транзакции к универсальному виду
        $transaction_data = $this->formalizeData($request);

		
		//ВЫПОЛНЯЕМ ПРОВЕРКИ
		$pk_create  = md5($request['id'] . sprintf ("%.2lf", $request['sum']).$request['clientid'].$request['orderid'].$this->pk_secret_key);
		
		$pk_new_param = explode(':::',$request['clientid']);
		$request['clientid'] = $pk_new_param[0];
		
		
		if($pk_create == $request['key']) {
		#
		#
		#
		//Если все хорошо выполняем и выодим ответ для ПС
		$transaction_data['type'] = self::OPERATION_AUTH_CAPTURE;
		$transaction_data['state'] = self::STATE_CAPTURED;
		$callback_method = self::CALLBACK_PAYMENT;	
		$transaction_data = $this->saveTransaction($transaction_data, $request);
		$result = $this->execAppCallback($callback_method,$transaction_data);

        if (!empty($result['result'])) {
            self::log($this->id, array('result' => 'success'));
            echo $message = 'OK '.md5($request['id'].$this->pk_secret_key);
			exit();
        } else {
            $message = !empty($result['error']) ? $result['error'] : 'wa transaction error';
            self::log($this->id, array('error' => $message));
            header("HTTP/1.0 403 Forbidden");
			echo $message;
			exit();
        }
		#
		#
		#
		} else {}
		//
			$message = 'Message digest incorrect';
            self::log($this->id, array('error' => $message));
            header("HTTP/1.0 403 Forbidden");
			echo $message;
			exit();
    }

	

	#
	//
	//Подготавливаем массив для вставки в БД и определяем тип
	//
	#
    protected function formalizeData($request) {
	// формируем полный список полей, относящихся к транзакциям, которые обрабатываются платежной системой payKeeper
	$fields = array(
            'id',
            'sum',
            'orderid',
            'clientid',
            'key',

        ); 
        foreach ($fields as $f) {
            if (!isset($request[$f])) {
                $request[$f] = null;
            }
        }
	
	// выполняем базовую обработку данных
	$transaction_data = parent::formalizeData($request);
	//Тип транзацкии
	$transaction_data['type'] = self::OPERATION_AUTH_CAPTURE;
	// идентификатор транзакции, присвоенный платежной системой
	$transaction_data['native_id'] = $request['id'];
	// номер заказа
	//$pk_new_param = explode(':::',$request['orderid']);
	$transaction_data['order_id'] = $request['orderid'];
	// сумма заказа
	$transaction_data['amount'] = number_format($request['sum'], 2, '.', '');
	// идентификатор валюты заказа
	$transaction_data['currency_id'] = 'RUB';
	$transaction_data['result'] = 1;
	$transaction_data['view_data'] = 'Оплачено через PayKeeper - статус ответа: success';
	$transaction_data['state'] = self::STATE_CAPTURED;
	
	return $transaction_data;
	}
	
	
//...	

}

